#include "H/Function_Init.H"

void ADC_Init(uint Channel);
unsigned int ADCValue = 0x0000;
bit AdcFlag = 0;

/***********ADCѡ*************/
#if (IC_MODEL == SC95F7617B || IC_MODEL == SC95F7616B)
	enum Channel {AIN0=0,AIN1,AIN2,AIN3,AIN4,AIN5,AIN6,AIN7,AIN8,AIN9,AIN10,AIN11,AIN12,AIN13,AIN14,AIN15,VDD4=31};
#endif

#if (IC_MODEL == SC95F7615B || IC_MODEL == SC95F7613B)
enum Channel {AIN4=4,AIN5,AIN6,AIN7,AIN12=12,AIN13,AIN14,AIN15,VDD4=31};
#endif
	
/*****************************************************
*ƣvoid ADC_Test(void)
*ܣADC
*ڲvoid
*ڲvoid
*****************************************************/
void ADC_Test(void)
{
	ADC_Init(AIN4);
	while(1)
	{
		ADCCON |= 0X40;   //ʼADCת
		while(!AdcFlag);	         		 //ȴ ADCת;
		AdcFlag = 0;
		ADCValue = (ADCVH<<4)+(ADCVL>>4);
	}
}
/*****************************************************
*ƣvoid ADC_Init(uint Channel)
*ܣADCʼ
*ڲChannel
*ڲvoid
*****************************************************/
void ADC_Init(uint Channel)
{
	ADCCON = 0X80|Channel;		//ADCADCƵΪ2M ,ѡChannelλADC
	if(Channel<8)
	{
		ADCCFG0 = 1<<Channel;   //ChannelΪ
	}
	else
	{
		ADCCFG1 = 1<<(Channel-8);   //ChannelΪ
	}
	ADCCFG2 = 0x10;			//ADCʱΪʱ
	IE |= 0X40;        //ADCж
	EA = 1;
}


void ADC_Interrupt(void) interrupt 6
{
	ADCCON &= ~(0X20);  //жϱ־λ
	AdcFlag = 1;
}