#include "H/Function_Init.H"
#include "IAP_Lib/IAP_Option_EW.h"
unsigned char code* POINT;	     //ָָ0x0000

#define IAP_APROM 0x00
#define IAP_UniqueID 0x01
#define IAP_EEPROM 0x02
#define IAP_LDROM 0x03

unsigned char IAP_Read(unsigned long IAP_IapAddr, unsigned char area);

void IAP_Test(void)
{
  unsigned char IapReadData1,IapReadData2;				//崢ݵı
	
  IAP_CodeSectorEraseOption(0xFFFE);			//CODE 0x1FFFEַ 
  IAP_CodeProgramByteOption(0xFFFE, 0x55);			//CODE 0x1FFFEַд0x55
  IapReadData1 = IAP_Read(0xFFFE, IAP_APROM);	//ȡCODE 0x1FFFEַ
	
  IAP_EEPROMSectorEraseOption(0x1000);			//EEPROM 0x1000ַ
  IAP_EEPROMProgramByteOption(0x1000, 0xAA);			//EEPROM 0x1000ַд0xAA
  IapReadData2 = IAP_Read(0x1000, IAP_EEPROM);		//ȡEEPROM 0x1000ַ
  while(1)
  {
    if((IapReadData1 == 0x55) && (IapReadData2 == 0xAA))
    {
      P02 = ~P02;
    }
    else
    {
      P03 = ~P03;
    }
  }
}

/**************************************************
*ƣunsigned char IAP_Read(unsigned long Add,unsigned char ADER)
*ܣByteȡ
*ڲAdd Ҫĵַ(0X00~0X1FFFFFLASHַ
*         DataҪдByte,ADER: APROMΪ00,EEPROMΪ02
*ڲvoid
**************************************************/
unsigned char IAP_Read(unsigned long Add, unsigned char Iapade)
{
  unsigned char IAP_IapData;
  //ROMBNKIAPADEEA
  unsigned char tempADER = IAPADE;
	unsigned char tempEA = EA;

  unsigned char code* point = 0;

  EA = 0;//رж

  IAPADE = Iapade;

  IAP_IapData = *(point + Add);

  //ָROMBNKIAPADEEAMOVCλó
  IAPADE = tempADER;
  EA = tempEA;

  return IAP_IapData;

}

void EEPROM_Write_k(long Dat)
{
	uchar i;
	uchar temp[4];
	temp[0] = (Dat >> 24) & 0xFF;
	temp[1] = (Dat >> 16) & 0xFF;
	temp[2] = (Dat >> 8) & 0xFF;
	temp[3] = Dat & 0xFF;
	IAP_EEPROMSectorEraseOption(0x1600);			//EEPROM 0x1000ַ!!!!עǰҳǰֽڣһβһҳ512Bytes
	for(i=0;i<4;i++)
	{
		IAP_EEPROMProgramByteOption(0x1600+i,temp[i]);			//EEPROM 0x1000ַд0xAA
	}
}

long EEPROM_Read_k(void)
{
	uchar i;
	uchar buff;
	long dat =0;
	for(i=0;i<4;i++)
	{	
		buff = IAP_Read(0x1600+i, IAP_EEPROM);
		dat |= (long)buff<<24-i*8;
	}
	return dat;
}


