#include "H/Function_Init.H" 

void Uart_Init(uint Freq,unsigned long int baud);
long Cclt_Power(uchar a, long b);

bit UartSendFlag = 0; //жϱ־λ
bit UartReceiveFlag = 0; //жϱ־λ

//˷aݣb
long Cclt_Power(uchar a, long b)
{
	uchar i;
	long temp;
	
	temp = 1;
	for(i=0;i<a;i++)
		temp = temp*b;
	return temp;
}

/*****************************************************
*ƣvoid Uart_Test(void)
*ܣUart
*ڲvoid
*ڲvoid
*****************************************************/
void Uart_Test(void)
{
	Uart_Init(32,9600);
}
/*****************************************************
*ƣvoid Uart_Init(uint Freq,unsigned long int baud)
*ܣUartжϳʼ
*ڲFreq-Ƶbaud-
*ڲvoid
*****************************************************/
void Uart_Init(uint Freq,unsigned long int baud)    //ѡTimer1Ϊźŷ
{
	P2CON &= 0xFC;   //TX/RXΪ
	P2PH  |= 0x03;
	SCON  |= 0X50;   //ͨŷʽΪģʽһ
	TXCON |= 0X03;	//UART0ʱԴΪʱ1
	TH1 = (Freq*1000000/baud)>>8;	  //ΪT1ʱ䣻
	TL1 = Freq*1000000/baud;
	TR1 = 0;	//SC95F761xBϵUARTOʹöʱ1ΪʱԴTR1Ϊ0
	ET1 = 0;	
	EUART = 1;     //Uartж
	EA = 1;
}

/*
void Uart_Init(uint Freq,unsigned long int baud)    //ѡTimer2Ϊźŷ
{
	P2CON &= 0xFC;   //TX/RXΪ
	P2PH  |= 0x03;

	SCON  |= 0X50;   //ͨŷʽΪģʽһ
    TXINX = 0x02;
	TMCON |= 0X04;
	TXMOD = 0X00;
	TXCON = 0X30;
	RCAPXH = Freq*1000000/baud/256;
	RCAPXL = Freq*1000000/baud%256;
	TRX = 0;
	ET2 = 0;
	EUART = 1;     //Uartж
	EA = 1;
}
*/

/*****************************************************
*ƣvoid UartInt(void) interrupt 4
*ܣUartжϺ
*ڲvoid
*ڲvoid
*****************************************************/
void UartInt(void) interrupt 4
{
	if(TI) //UART0ж
	{
		TI = 0;	
		UartSendFlag = 1;		
	}
	if(RI) //UART0ж
	{
		RI = 0;	
		UartReceiveFlag = 1;
	}	
}

void UART_SendByte(uchar Byte)//ֽڷ
{
		SBUF = Byte;
		while(!UartSendFlag);
		UartSendFlag = 0;
}

void UART_SendLong(long Dat)//32λӸߵͷ
{
	uchar i;
	uchar temp[4];
	temp[0] = (Dat >> 24) & 0xFF;
	temp[1] = (Dat >> 16) & 0xFF;
	temp[2] = (Dat >> 8) & 0xFF;
	temp[3] = Dat & 0xFF;
	for(i=0;i<4;i++)
	{
		UART_SendByte(temp[i]);
	}
}

void UART_Send_VOFA(long uart_buff)
{
	uchar j;
	uchar buff;
	uchar vofa_buff[8];
	bit negative=0;
	
	if(uart_buff<0)//תԴ
	{
		uart_buff=~uart_buff+1;
		negative = 1;
		
	}
	for(j=0;j<8;j++)
	{
		vofa_buff[j] = (uart_buff % Cclt_Power(j+1,10)) / Cclt_Power(j,10);//16ת10ƣС˷棬λڵֽ
	}	
	if(negative)
		UART_SendByte(45);//
	for(j=0;j<8;j++)
	{
		buff = vofa_buff[7-j]+48;//ΪַҪ͸λ
		UART_SendByte(buff);
	}

}

void UART_SendAll(long* Dat)//4ԭʼݶ
{
	uchar i,j;
	uchar temp[4];
	
	for(j=0;j<4;j++)
	{
		temp[0] = (Dat[j] >> 24) & 0xFF;
		temp[1] = (Dat[j] >> 16) & 0xFF;
		temp[2] = (Dat[j] >> 8) & 0xFF;
		temp[3] = Dat[j] & 0xFF;
		for(i=0;i<4;i++)
		{
			UART_SendByte(temp[i]);
		}
	}

}
